;==[ Template file for TFANN ]=================================================
;
; This file is used by TFANN for creating announce. You can achieve the desired
; appearance of the announce by modifying the file.
;
; WARNING:  TFANN will be searching the file in the current directory!
; To define an alternate name or path run the program with special parameters.
; For example:
; TFANN defnotif.txt announce.txt #C:\NET\TEMPLATE\mytpl.tpl
;
;==============================================================================
;
; If variable LowFName has value 'Yes' the names of the files in the announce
; will be in lower case, if 'No' - upper case. Default - 'No'.

  LowFName   Yes

; Below are defined four sections:
; AnnHeader, AnnAreaHeader, AnnText, AnnAreaFooter  AnnFooter.
; It is not necessary to define all the sections, but for normal work by all
; means define at least AnnText.
; The description of each section is to begin with its name and end with the
; word 'End'. Inside the section you can use the variables described below.
; Between the symbol '%' and the name of the variable you can define the length.
; Format: %[width]VAR
; If the output value has less than width characters, the output is padded
; with blanks (right-padded if width is negative, left-padded otherwise).
;
; List of used variables:
; -----------------------
;
; Available in all sections:
; %TH  - current time
; %DT  - current date
;
; Available in AnnAreaHeader, AnnText and AnnAreaFooter only:
; %AT  - areatag
; %AD  - area description
; %AS  - total size of files in area
; %A#  - total number of files in area
;
; Available in AnnText only:
; %FN  - file name
; %FS  - file size
; %FD  - file description
;
;
; Section AnnHeader contains the strings, will be added
; at the beginning of announce.

AnnHeader
 Announce created at %TH, %DT

End

; Section AnnAreaHeader contains the strings, which will be added
; at the beginning of each area.

AnnAreaHeader
 Area: %-15AT Comment: %AD
 
End

; Section AnnText contains the strings, which will be added
; to each file.

AnnText
 %12FN [%8FS] %-52FD
End

; Section AnnAreaFooter contains the strings, which will be added
; to the end of each area.

AnnAreaFooter
 
 Total: %10AS bytes in %-3A# files
 
End

; Section AnnFooter contains the strings, which will be added
; to the end of announce.

AnnFooter

 > File requests are available 24 hours every day.
 > Freq FILES for an allfiles listing.
 > Only listed systems will be honored.
 
End

;
;==========================[ End of template file ]============================
